#!/usr/bin/perl -w
###############################################################################
#
#   Name:           ExtIndex_NULL
#   
#   Description:    Implementation of the ExtIndex interface when no external
#		    data is available.
#                   The ExtIndex interface defines two functions:
#                       get_seq_by_id
#                       get_seq_by_acc
#
#                   These functions are called from ExtIndex.pm with a hashref
#                   of the following arguments:
#
#                   'EXE'       :   The executable to be used to search with
#                                   (e.g. getz)
#                   'DB'        :   The database to search (e.g. EMBL)
#                   'ID|ACC'    :   ID or Accession to search for
#                   'FORMAT'    :   Return FASTA or EMBL format
#                   'OPTIONS'   :   Return 'id', 'acc', 'desc', 'seq', 'all'
#                                   Describes what part of the results to 
#                                   return.
#
#
#   History:        2000-12-11  jws initial version
#
###############################################################################
package ExtIndex_NULL;
use strict;

sub get_seq_by_id{
    return;
}


sub get_seq_by_acc{
    return;

}

1;
