###############################################################################
#!/bin/perl -w
#
# Programmer: Kuan Chang
# Version: 1.1
# Date: 02/26/2002
#
###############################################################################

use strict;
use DBI;
use CSHL::Config;

###############################################################################
# Connect to the database
#
my $dbh = DBI->connect( OntologyDataSource, OntologyDBUser, OntologyDBPassword ) || die "Can't connect to Oracle database: $DBI::errstr\n";
###############################################################################

#my $MAX_ASSOCIATION_ID = 242494;
my $MAX_GO_ASSOCIATION_ID = 232628;
my $label = "_0226";
my ( $a, $b, $c, $d, $e, $f);
###############################################################################
my $sth = $dbh->prepare( "SELECT * FROM association where association_id > $MAX_GO_ASSOCIATION_ID" );
$sth->execute();

my $contributor_file = "extra_association$label.txt";
open (COUT, ">$contributor_file") || die "cannot open $contributor_file for writing: $!";

while( ( $a, $b, $c, $d, $e, $f) = $sth->fetchrow_array ) {
    print COUT ( "$a\t$b\t$c\t$d\t$e\t$f\n" );
    print ( "$a\n" );
}

$sth->finish();
close(COUT) || die "can't close $contributor_file: $!\n";

###############################
#################################

$dbh->disconnect || warn $dbh->errstr;

exit;
